package ss2011.se.dp;

import static org.junit.Assert.*;

import org.junit.Test;

import ss2011.se.dp.messaging.Attachment;
import ss2011.se.dp.messaging.Message;


public class HA7A2Test
{
	
	/**
	 * Die Beschreibung was hier zu tun ist, befindet sich im PDF, Seite 2.
	 */

	@Test
	public void testMessageSimpleClone()
	{
		Message m = new Message();
		m.setFrom("Alice");
		m.setTo("Bob");
		m.setContent("Hallo, wie gehts?");
		
		Message copy = null; // FIXME: use m.clone();
		
		assertNotNull(copy);
		assertEquals(m, copy);
		assertNotSame(m, copy);
		
		assertEquals(m.getFrom(), copy.getFrom());
		assertEquals(m.getTo(), copy.getTo());
		assertEquals(m.getContent(), copy.getContent());
	}
	
	@Test
	public void testMessageEquals()
	{
		Message m1 = new Message();
		m1.setFrom("Charlie");
		m1.setTo("All");
		m1.setContent("Wo seid ihr?");
		
		Message m2 = new Message();
		m2.setFrom("Charlie");
		m2.setTo("All");
		m2.setContent("Wo seid ihr?");	
		
		assertEquals(m1, m2);
	}
	
	@Test
	public void testMessageDeepClone()
	{
		Message m = new Message();
		m.setFrom("Alice");
		m.setTo("Bob");
		m.setContent("Hallo, wie gehts?");
		
		Attachment a1 = new Attachment("Bewerbung.zip");
		m.addAttachment(a1);
		Attachment a2 = new Attachment("Urlaubsfoto.jpg");
		m.addAttachment(a2);
		
		Message copy = m.copy();
		
		// FIXME:
		/*
		 * Vervollstaendige den JUnit-Test, so dass er prueft:
		 * - ob die Messages und Attachments gleich sind (equals())
		 * - ob die Messages verschiedene Instanzen sind (s.o., notSame())
		 * - die Anzahl der Attachments von m und copy gleich sind
		 * - die einzelnen Attachments von m durchgeht und fuer jedes prueft:
		 * 	- gibt es ein solches auch bei copy?
		 * 	- ist dieses gleich (equals()), aber nicht dasselbe (notSame())?
		 * - Entwerfe den Test/die Asserts so, dass er tolerant gegen Umsortierungen der Attachments ist!
		 */
	}
	
}
