package ss2011.se.dp.filesystem;

import ss2011.se.dp.visitors.CountFilesVisitor;
import ss2011.se.dp.visitors.Visitor;

public class RegularFile extends AbstractFile
{

    private long size;

    public RegularFile(AbstractFile parent, String name, long size)
    {
        super(parent, name);
        this.size = size;
    }

    public long getSize()
    {
        return size;
    }
    
    public void accept(Visitor visitor) {
    	visitor.visit(this);
    }
}
