package ss2011.se.dp.messaging;

import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;

public class Message
{

	private String from;
	private String to;
	private String content;
	
	private Collection<Attachment> attachments = new HashSet<Attachment>();

	public String getFrom()
	{
		return from;
	}

	public void setFrom(String from)
	{
		this.from = from;
	}

	public String getTo()
	{
		return to;
	}

	public void setTo(String to)
	{
		this.to = to;
	}

	public String getContent()
	{
		return content;
	}

	public void setContent(String content)
	{
		this.content = content;
	}

	public boolean addAttachment(Attachment a)
	{
		return this.attachments.add(a);
	}
	
	public boolean removeAttachment(Attachment a)
	{
		return this.attachments.remove(a);
	}
	
	public Collection<Attachment> getAttachments()
	{
		return Collections.unmodifiableCollection(attachments);
	}

	public Message copy()
	{
		throw new UnsupportedOperationException();
	}
	
}
