package ss2011.se.dp.visitors;

import ss2011.se.dp.filesystem.Archive;
import ss2011.se.dp.filesystem.Directory;
import ss2011.se.dp.filesystem.RegularFile;


public class SummarizeFileSizeVisitor implements Visitor {

	private long totalSize = 0;

	@Override
	public void visit(RegularFile file) {
		totalSize = totalSize + file.getSize();
	}

	@Override
	public void visit(Archive file) {
		totalSize = totalSize + file.getSize();
	}

	@Override
	public void visit(Directory file) {
		totalSize = totalSize + file.getSize();
	}
	
	public long getTotalSize() {
		return totalSize;
	}
}
